package org.seasar.javelin.jmx.viewer.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.seasar.javelin.jmx.viewer.editpart.ComponentEditPart;

public class ComponentModel extends AbstractModel
{
	// ύX̎ނʂ邽߂̕
	public static final String P_CONSTRAINT = "_constraint";

	public static final String P_CLASS_NAME = "_className";

	public static final String P_INVOCATION = "_invocation";
	
	public static final String P_SOURCE_CONNECTION = "_source_connection";

	public static final String P_TARGET_CONNECTION = "_target_connection";

	private String className_;

	private ComponentEditPart part_;
	
	private List<InvocationModel> invocationList_ = 
		new ArrayList<InvocationModel>();

	private Rectangle constraint_; // 

	// ȉIPropertySourceC^[tFCX
	// \bḧꕔI[o[Ch
	public IPropertyDescriptor[] getPropertyDescriptors()
	{
		List<IPropertyDescriptor> list = 
			new ArrayList<IPropertyDescriptor>();
		list.add(new TextPropertyDescriptor(P_CLASS_NAME, "NX"));
		for (int index = 0; index < getInvocationList().size(); index++)
		{
			list.add(
			    list.size() - 1
				, new TextPropertyDescriptor(
					P_INVOCATION + index
					, getInvocationList().get(index).getMethodName()));
		}

		IPropertyDescriptor[] descriptors = 
			list.toArray(new IPropertyDescriptor[list.size()]);
		return descriptors;

	}

	public Object getPropertyValue(Object id)
	{
		if (id.equals(P_CLASS_NAME))
		{
			// vpeBEr[ɕ\f[^Ԃ
			return className_;
		}
		if (id instanceof String)
		{
			String text = (String)id;
			if (text.startsWith(P_INVOCATION))
			{
				int num = Integer.parseInt(text.substring(P_INVOCATION.length()));
				return getInvocationList().get(num);
			}
		}
		
		return null;
	}

	public boolean isPropertySet(Object id)
	{
		if (id.equals(P_CLASS_NAME))
		{
			return true;
		}
		
		if (id instanceof String)
		{
			String text = (String)id;
			if (text.startsWith(P_INVOCATION))
			{
				return true;
			}
		}
		return false;
	}

	public void setPropertyValue(Object id, Object value)
	{
	}

	public String getClassName()
	{
		return className_;
	}

	public void setClassName(String className)
	{
		className_ = className;
	    firePropertyChange(P_CLASS_NAME, null, className_);
	}

	public void addInvocation(InvocationModel invocation)
	{
		invocationList_.add(invocation);
		invocation.setComponent(this);
		Collections.sort(invocationList_);
	}

	public List<InvocationModel> getInvocationList()
	{
		return invocationList_;
	}

	public Rectangle getConstraint()
	{
		return constraint_;
	}

	public void setConstraint(Rectangle constraint)
	{
		constraint_ = constraint;
		// ύX̒ʒm
		firePropertyChange(P_CONSTRAINT, null, constraint);
	}

	public void setEditPart(ComponentEditPart part)
	{
		part_ = part;
	}
	
	public ComponentEditPart getEditPart()
	{
		return part_;
	}
	
	// ̃fLтĂRlNṼXg
	private List sourceConnections = new ArrayList();

	// ̃fɌĒĂRlNṼXg
	private List targetConnections = new ArrayList();

	// ̃foRlNV f̒ǉ
	public void addSourceConnection(Object connx)
	{
		sourceConnections.add(connx);
		firePropertyChange(P_SOURCE_CONNECTION, null, null);
	}

	// ̃fɐڑRlNV f̒ǉ
	public void addTargetConnection(Object connx)
	{
		targetConnections.add(connx);
		firePropertyChange(P_TARGET_CONNECTION, null, null);
	}

	// ̃fڑƂRlNṼXgԂ
	public List getModelSourceConnections()
	{
		return sourceConnections;
	}

	// ̃fڑƂRlNṼXgԂ
	public List getModelTargetConnections()
	{
		return targetConnections;
	}

	// ̃fRlNṼ\[X؂藣
	public void removeSourceConnection(Object connx)
	{
		sourceConnections.remove(connx);
		firePropertyChange(P_SOURCE_CONNECTION, null, null);
	}

	// ̃fRlNṼ^[Qbg؂藣
	public void removeTargetConnection(Object connx)
	{
		targetConnections.remove(connx);
		firePropertyChange(P_TARGET_CONNECTION, null, null);
	}
}
